/****************************************************************	
* Name : Atul Nayak						*
* start.hxx : Header file for class start			*
****************************************************************/	     

class start
{

	private:
		
		// number of polygons that make a start
		int noOfPolygons;	

		// the color of the start object	
		GLfloat colors[3];

		// vector of number of vertices in each polygon		
		vector<int> noOfVertices;

		// vertices in each polygon	
		vector<GLfloat> vertices;

		// the X position in the Maze array at start	
		int positionX;

		// the Y position in the Maze array at start	
		int positionY;
	
	public:

		// constructor - reads space.txt
		start();

		// draw the start object at the specified position
		void drawStart(int x, int y);

		// return positionX
		int getPositionX();

		// return positionY
		int getPositionY();

		// set the color to it's maximum intensity
		void brightestColor();

		// set the color to it's minimum intensity
		void darkestColor();

		// set the door color to an intermediate value specified
		void changeColor(float);

		// destructor
		~start();

};
