/****************************************************************	
* Name : Atul Nayak						*
* door.cxx : Header file for class wall				*
****************************************************************/	     
class wall
{

	private:
		// number of polygons that make a wall
		int noOfPolygons;

		// the color of the wall		
		GLfloat colors[3];	

		// vector of number of vertices in each polygon
		vector<int> noOfVertices;	

		// vertices in each polygon
		vector<GLfloat> vertices;	

		// the X position of the door in the Maze array at start
		int positionX;

		// the Y position of the door in the Maze array at start	
		int positionY;

		// the minimum x coordinate edge of the wall object 
		float leftEdge;

		// the maximum x coordinate edge of the wall object 	
		float rightEdge;

		// the maximum x coordinate edge of the wall object 	
		float topEdge;

		// the minimum y coordinate edge of the wall object 	
		float bottomEdge;
		int wallIsDoor;
			
	public:

		// conttsructor - reads the wall.txt
		wall();
		
		// draw the Door at the position specified
		void drawWall(int x, int y);

		// return positionX
		int getPositionX();

		// return positionY
		int getPositionY();

		// set the wall color to it's maximum intensity
		void brightestColor();

		// set the wall color to it's minimum intensity
		void darkestColor();

		// set the wall color to an intermediate value specified
		void changeColor(float);

		// return leftEdge
		float getLeftEdge();

		// return rightEdge
		float getRightEdge();

		// return topEdge
		float getTopEdge();

		// return bottomEdge
		float getBottomEdge();

		// set wallIsDoor
		void setWallIsDoor();
		
		// destructor
		~wall();
};
